#!/bin/bash
#------------------------------------------------------------------------------
# /var/install/config.d/roundcube_show_folder_size.sh
#
# Last Update: 2021-03-29 se, sebastian(dot)ertz(at)tk(minus)ertz(dot)de
#
# Copyright (c) 2001-2024 the eisfair team, team(at)eisfair(dot)org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------
#==============================================================================
# { Common 2021-05-25
#==============================================================================
. /var/install/include/eislib
declare -a VARS_RENAME=()
declare -a VARS_MODIFY=()
declare -a VARS_ADD=()
declare -a VARS_DEL=()
_INSTALL="no"
Warn(){
	while [[ $# -gt 0 ]]; do
		[[ $1 ]] && mecho -n "Roundcube Plugin Show Folder Size: " && mecho --warn "$1"
		shift
	done
}
Abort(){
	Warn "$@"
	mecho -n "Roundcube Plugin Show Folder Size: "; mecho --warn "Pre-requisites not met, abort config!"
	exit 1
}
FileheaderPrint(){
	printf "#----------------------------------------------------------------------------\n"
	printf "# %s\n" "$1"
	printf "# generated by /var/install/config.d/roundcube_show_folder_size.sh\n"
	printf "#\n"
	printf "# Do not edit this file, edit /etc/config.d/roundcube_show_folder_size\n"
	printf "# Creation Date: %(%Y-%m-%d)T Time: %(%H:%M:%S)T\n" -1 -1
	printf "#----------------------------------------------------------------------------\n"
}
FileheaderWrite(){
	[[ $1 ]] && FileheaderPrint "$1" > "$1"
}
ConfigLoad(){
	[[ -f /etc/config.d/roundcube_show_folder_size ]] || Abort "configuration file '/etc/config.d/roundcube_show_folder_size' not found!"
	chmod 0600 /etc/config.d/roundcube_show_folder_size
	chown root:root /etc/config.d/roundcube_show_folder_size
	. /etc/config.d/roundcube_show_folder_size
}
_VarIsSet(){
	local _var
	eval _var="\${${1}+EMPTY}"
	[[ $1 && $_var ]]
}
VarDel(){
	[[ $1 ]] && _VarIsSet "$1" && VARS_DEL+=("$1")
}
VarModify(){
	if [[ $1 ]]; then
		local value=""
		_VarIsSet "$1" && eval value="\$$1"
		if [[ $value != "$2" ]]; then
			eval "$1"="\$2"
			VARS_MODIFY+=("$1, '$value' -> '$2'")
		fi
	fi
}
VarRename(){
	if [[ $1 && $2 ]] && _VarIsSet "$1"; then
		eval "$2"="\$$1"
		VARS_RENAME+=("$1 -> '$2'")
	fi
}
PrintGPL(){
	PrintLine
	printf "# /etc/config.d/roundcube_show_folder_size - configuration file for roundcube_show_folder_size \n"
	printf "#\n"
	printf "# Creation   :  2024-04-23 se\n"
	printf "# Last Update:  %(%Y-%m-%d)T %s\n" -1 "$LOGNAME"
	printf "#\n"
	printf "# Copyright (c) 2001-%(%Y)T the eisfair team, team(at)eisfair(dot)org\n" -1
	printf "#\n"
	printf "# This program is free software; you can redistribute it and/or modify\n"
	printf "# it under the terms of the GNU General Public License as published by\n"
	printf "# the Free Software Foundation; either version 2 of the License, or\n"
	printf "# (at your option) any later version.\n"
	PrintLine
	printf "\n"
}
PrintHeader(){
	PrintGroup "Roundcube Plugin Show Folder Size Version 3.4.0" "(Internal Program Version: 0.7.19)"
}
PrintGroup(){
	printf "\n"
	PrintLine
	printf "# %s\n" "$@"
	PrintLine
	printf "\n"
}
PrintVar(){
	if [[ $# -eq 1 || $# -eq 2 ]]; then
		local value="$2"
		if _VarIsSet "$1"; then
			eval value="\$$1"
		else
			eval "$1"="\$value"
			VARS_ADD+=("$1='$value'")
		fi
		printf "%s='%s'\n" "$1" "$value"
	fi
}
PrintEnd(){
	printf "\n"
	PrintLine
	printf "# End\n"
	PrintLine
}
PrintLine(){
	printf "#------------------------------------------------------------------------------\n"
}
InstallConfig(){
	local _update=false
	_INSTALL="yes"
	(
		PrintGPL
		InstallConfigPrint
		PrintEnd
	)>/etc/default.d/roundcube_show_folder_size
	chmod 0600 /etc/default.d/roundcube_show_folder_size
	chown root:root /etc/default.d/roundcube_show_folder_size
	if [[ -f /etc/config.d/roundcube_show_folder_size ]]; then
		_update=true
		/var/install/bin/backup-file --quiet "roundcube_show_folder_size"
		. /etc/config.d/roundcube_show_folder_size
	fi
	VARS_RENAME=()
	VARS_MODIFY=()
	VARS_ADD=()
	VARS_DEL=()
	{
		PrintGPL
		InstallConfigPrint
		PrintEnd
	}>/etc/config.d/roundcube_show_folder_size
	chmod 0600 /etc/config.d/roundcube_show_folder_size
	chown root:root /etc/config.d/roundcube_show_folder_size
	if $_update; then
		# rename
		if [[ ${#VARS_RENAME[@]} -gt 0 ]]; then
			mecho --info "renaming parameter(s) ..."
			printf -- "- %s\n" "${VARS_RENAME[@]}"
		fi
		# modify
		if [[ ${#VARS_MODIFY[@]} -gt 0 ]]; then
			mecho --info "modifying parameter(s) ..."
			printf -- "- %s\n" "${VARS_MODIFY[@]}"
		fi
		# add
		if [[ ${#VARS_ADD[@]} -gt 0 ]]; then
			mecho --info "adding new parameter(s) ..."
			printf -- "- %s\n" "${VARS_ADD[@]}"
		fi
		# delete
		if [[ ${#VARS_DEL[@]} -gt 0 ]]; then
			mecho --info "deleting old parameter(s) ..."
			printf -- "- %s\n" "${VARS_DEL[@]}"
		fi
		if [[ ${#VARS_RENAME[@]} -gt 0 || ${#VARS_MODIFY[@]} -gt 0 || ${#VARS_ADD[@]} -gt 0 || ${#VARS_DEL[@]} -gt 0 ]]; then
			mecho --info "... read documentation for parameter(s)!"
		fi
	fi
}
#==============================================================================
# } Common
#==============================================================================
#==============================================================================
# { Roundcube 2023-01-08
#==============================================================================
RmRoundcubeMenu(){
	/var/install/bin/del-menu "setup.services.menu" "setup.services.mail.modules.roundcube_show_folder_size.menu"
	/var/install/bin/del-menu "setup.services.mail.modules.menu" "setup.services.mail.modules.roundcube_show_folder_size.menu"
	rm -f /var/install/menu/roundcube_show_folder_size.*
}
RoundcubeMenu(){
	if [[ -x /var/install/config.d/mail.sh ]]; then
		/var/install/bin/del-menu "setup.services.menu" "setup.services.mail.modules.roundcube_show_folder_size.menu"
		/var/install/config.d/mail.sh --updatemodulesmenu
	else
		/var/install/bin/add-menu --menu "setup.services.menu" "setup.services.mail.modules.roundcube_show_folder_size.menu" "Roundcube Plugin Show Folder Size administration"
	fi
}
RmRoundcube(){
	if [[ -s /var/roundcube/roundcube_show_folder_size ]]; then
		local rc_dir_plugin
		while read -r rc_dir_plugin; do
			if [[ $rc_dir_plugin ]] && rc_dir_plugin="${rc_dir_plugin%*/}" && [[ -d "$rc_dir_plugin/" ]]; then
				rm -rf "${rc_dir_plugin:?}/"
			fi
		done < /var/roundcube/roundcube_show_folder_size
		rm -f /var/roundcube/roundcube_show_folder_size
	fi
}
RmRoundcubeConfig(){
	if [[ -s /var/roundcube/roundcube_show_folder_size ]]; then
		local rc_dir_plugin
		while read -r rc_dir_plugin; do
			if [[ $rc_dir_plugin && -f "$rc_dir_plugin/config.inc.php" ]]; then
				rm -f "${rc_dir_plugin}/config.inc.php"
			fi
		done < /var/roundcube/roundcube_show_folder_size
		rm -f /var/roundcube/roundcube_show_folder_size
	fi
}
Roundcube(){
	/var/install/config.d/roundcube.sh --set-access-rights
}
RoundcubeCheck(){
	mecho -n "Roundcube Plugin Show Folder Size: Package 'roundcube' "
	if [[ -f /etc/config.d/roundcube ]]; then
		. /etc/config.d/roundcube
		if [[ ${START_ROUNDCUBE:-no} == "yes" ]]; then
			mecho --info "enabled"
			return 0
		else
			mecho -n --warn "disabled"
			mecho ", set parameter START_ROUNDCUBE='yes'!"
		fi
	else
		mecho --warn "not installed"
	fi
	Abort
}
RoundcubeForEach(){
	[[ -f /etc/config.d/roundcube ]] && . /etc/config.d/roundcube
	if [[ ${START_ROUNDCUBE:-no} == "yes" ]]; then
		local idx
		local rc_n_active
		local rc_n_document_root
		idx=1
		while [[ $idx -le "${ROUNDCUBE_N:-0}" ]]; do
			eval rc_n_active="\$ROUNDCUBE_${idx}_ACTIVE"
			eval rc_n_document_root="\$ROUNDCUBE_${idx}_DOCUMENT_ROOT"
			[[ ${rc_n_active:-no} == "yes" && $rc_n_document_root && -d "$rc_n_document_root/" ]] && RoundcubeConfig "$rc_n_document_root"
			((idx++))
		done
	fi
}
RoundcubeIncHeader(){
	printf "<?php\n"
	FileheaderPrint "$1"
}
RoundcubeIncValue(){
	if [[ $# -eq 2 ]]; then
		local value
		case "$2" in
			array\(* ) value="$2"   ;;
			yes|true ) value="true" ;;
			no|false ) value="false";;
			null|NULL) value="null" ;;
			*        ) value="'$2'" ;;
		esac
		printf "\$config['%s']=%s;\n" "$1" "$value"
	fi
}
#==============================================================================
# } Roundcube
#==============================================================================

#==============================================================================
# Config
#==============================================================================
RoundcubeConfig(){
	if [[ $1 && -d "$1/" ]]; then
		local rc_dir_plugin="$1/plugins/show_folder_size"
		printf "%s\n" "$rc_dir_plugin" >> /var/roundcube/roundcube_show_folder_size
		mecho "Roundcube Plugin Show Folder Size: Copy  '$rc_dir_plugin/'"
		cp -r "/usr/share/roundcube_show_folder_size" "$rc_dir_plugin"
		mecho --ok
		mecho "Roundcube Plugin Show Folder Size: Write '$rc_dir_plugin/config.inc.php'"
		{
			RoundcubeIncHeader "$rc_dir_plugin/config.inc.php"
		} > "$rc_dir_plugin/config.inc.php"
		mecho --ok
	fi
}
Config(){
	RmRoundcube
	ConfigLoad
	if [[ ${START_ROUNDCUBE_SHOW_FOLDER_SIZE:-no} == "yes" ]]; then
		RoundcubeCheck
		RoundcubeForEach
		Roundcube
	fi
}

#==============================================================================
# Install
#==============================================================================
Install(){
	RoundcubeMenu
	InstallConfig
	Config
}
InstallConfigPrint(){
	PrintHeader
	PrintVar "START_ROUNDCUBE_SHOW_FOLDER_SIZE" "no"
}

#==============================================================================
# Update
#==============================================================================
Update(){
	RmRoundcube
}

#==============================================================================
# Uninstall
#==============================================================================
Uninstall(){
	Update
	RmRoundcubeMenu
	rm -f \
		/etc/backup.d/roundcube_show_folder_size.* \
		/etc/config.d/roundcube_show_folder_size \
		/etc/default.d/roundcube_show_folder_size \
		/var/roundcube/roundcube_show_folder_size
}

#==============================================================================
# Main
#==============================================================================
Main(){
	case "${1,,}" in
		install  ) Install  ;;
		update   ) Update   ;;
		uninstall) Uninstall;;
		*        ) Config   ;;
	esac
}
Main "$@"

#==============================================================================
# End
#==============================================================================
exit 0
